
#ifndef NOISEDATASETCLASS
#define NOISEDATASETCLASS

#include "DataSet.h"
#include "Noise.h"

// Perlin noise,
// based on "Hypertextures" by Ken Perlin

class NoiseDataSet : public Noise, public DataSet {

  public:

  NoiseDataSet(){
    DataSet::DataSet();
    Noise::Noise();
    maxValue = 1.0f;
  }

  // virtual function
  float val(const SbVec3f &x, float b=0.5, float g=0.5) const {
    return biasFunc(gainFunc(turbulence(x), g), b);
  }
  
  float val(int x, int y, int z) const {
    SbVec3f a = min+SbVec3f(voxel[0]*(x+0.5f),
			    voxel[1]*(y+0.5f),
			    voxel[2]*(z+0.5f));
    return val(a);
  }

  void useData(char *filename, int _dim=217, int header=0, int fourBytes=0,
	       SbVec3f _min = SbVec3f(0.0, 0.0, 0.0),
	       SbVec3f _max = SbVec3f(100.0, 100.0, 100.0));
};

#endif /* NOISEDATASETCLASS */
