
void HSVtoRGB(float h, float s, float v, float &r,
	      float &g, float &b){
  // adapted from http://www.research.compaq.com/SRC/m3sources/html
  //                    /color/src/Color.m3.html#FromHSV

  if (v==0.0){
    r=g=b=0.0;
    return; // Black
  }
  if (s==0.0){
    r=g=b=v;
    return; // Gray
  }
  if (h==1.0) h=0.0;
  int i=(int)(h*6.0);
  float f=h*6.0-i;
  float p=v*(1.0-s);
  float q=v*(1.0-s*f);
  float t=v*(1.0-s*(1.0-f));
  switch(i){
  case 0: r=v; g=t; b=p;
    break;
  case 1: r=q; g=v; b=p;
    break;
  case 2: r=p; g=v; b=t;
    break;
  case 3: r=p; g=q; b=v;
    break;
  case 4: r=t; g=p; b=v;
    break;
  case 5: r=v; g=p; b=q;
    break;
  }
  
  return;  
}
