#include <iostream>
#include <Inventor/SbLinear.h>

// g++ rotateCam.cxx -lInventor -o rotateCam

using namespace std;

int main(int argc, char* argv[]){
  cout << "This program takes a camera position & orientation\n"
       << "along with a rotation and gives the new position & orientation.\n";
  
  cout << "Enter camera position x y z (cut + paste from .iv file):\n";

  float x, y, z, t;
  cin >> x >> y >> z;
  SbVec3f pos(x,y,z);

  cout << "Enter camera rotation x y z t (cut + paste from .iv file):\n";
  cin >> x >> y >> z >> t;
  SbRotation orient(SbVec3f(x,y,z), t);

  cout << "Enter rotation to apply, x y z t (cut + paste from .iv file):\n";
  cin >> x >> y >> z >> t;
  SbRotation rot(SbVec3f(x,y,z), t);
  
  cout << "New position and orientation:\n";
  rot.multVec(pos,pos);
  cout << "position "
       << pos[0] << " " << pos[1] << " " << pos[2] << "\n";
  
  SbVec3f axis;
  float radians;
  orient *= rot;
  orient.getValue(axis, radians);
  cout << "orientation "
       << axis[0] << " " << axis[1] << " " << axis[2] << " " << radians << "\n";

  return(0);
}
