#include <iostream>
#include <float.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>
#include <time.h>

using namespace std;

// time a set of instructions
#define TIME(x) { struct timeval start, end;  \
                gettimeofday(&start, NULL); \
                x;                          \
 	        gettimeofday(&end, NULL);   \
	        cerr << "Time: "  << delay(start, end) << "ms" << endl; }
// Compute the delay between t1 and t2 in milliseconds
inline long delay (struct timeval t1, struct timeval t2){
  long d;
    
  d = (t2.tv_sec - t1.tv_sec) * 1000;
  d+= ((t2.tv_usec - t1.tv_usec + 500) / 1000);
  return(d);
}

float v(float x){
  return x;
}

// Idea from article by Altair in vol. 14 of Hugi diskmag:
// http://www.hugi.scene.org/main.php?page=hugi14
//
// 18 times faster than logf(x)*(1/logf(2)) in my testing.
float fastlog2(float x){
  return ((int &)x >> 23)-127;
}

int main(int argc, char *argv[]){

  float x = atof(argv[1]);
  cerr << "x=" << x << "\n";
  cerr << "    log2=" << logf(x)/logf(2) << "\n";
  cerr << "fastlog2=" << fastlog2(x) << "\n";

  int num=1e8;
  TIME(for (int i=0; i<num; i++) (log2(x)*(1/logf(2))););
  TIME(for (int i=0; i<num; i++) fastlog2(x););
  return 0;
}
