#!/bin/tcsh
#
# Run this second, after simulate.csh, from the main directory.
#
# This script renders images from the density files in dumpfiles/
# and places the render (.png and .hdr) in frames/.

foreach i (dumpfiles/vort.dens.*.dump)

set outfile=frames/$i:t:r.hi.png

# skip existing files
if ( -e $outfile ) then
  continue
endif

# Most rendering time in the early frames is spent shooting photons, since the
# chance of hitting the smoke is small.  Changing vphotons from 1000000 to
# 500000 will cut render time in half.
pane/pane --stepsize=1 -a0 -r --3ddata=$i \
floor.iv -d552x800 -u100 -o $outfile --silent --3ddim=180x260x180 \
--3dmult=10000 --3dmax=100,144.4,100 --vphotons=1000000 \
--vestimate=30 --lightsamples=4 -T none --exposure=6

end

